<?php
	if(isset($_REQUEST['action'])) 
	{
		$action = wpr_sanitize($_GET['action']);
		switch ($action)
		{
			case 'create':
				create_product();
				break;
			case 'delete':
				delete_product();
				break;
			case 'edit':
				edit_product();
				break;
			default:
				//just list what we have now - go through the html just below this code
		}
	}
?>

<div class="wrap">
	<h2>Manage Products</h2>
</div>
<table class="widefat">
	<thead>
		<tr>
			<th scope="col">Product Name</th>
			<th scope="col">Purchasing customer can subscribe via Form to Customer Newsletter </th>
			<th scope="col">Autoresponder</th>
			<th scope="col">Actions</th>
		</tr>
	</thead>
	
	<?php
		global $wpdb;
		$configuredProducts = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."EVI_PRODUCTS");
	
		if (count($configuredProducts))
		{
			foreach ($configuredProducts as $product)
			{			
				$form = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_subscription_form where id=".$product->fid);
				$form=$form[0];
				$newsletter = _wpr_newsletter_get($form->nid);

				$autoresponders = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_autoresponders where id=".$product->aid);
				$autoresponder = $autoresponders[0];
				?>
					<tr>
						<td><?php echo $product->item_name ?></td>
						<td><?php echo $form->name != '' ? $form->name .' | '. $newsletter->name : 'None' ?></td>
						<td><?php echo $autoresponder->name != '' ? $autoresponder->name : 'None' ?></td>
						
						<td>
							<input type="button" value="Edit Product" class="button" 
									onclick="window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php&action=edit&id=<?php echo $product->id ?>';" />
							<input type="button" value="Delete" class="button"
								onclick="window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php&action=delete&id=<?php echo $product->id ?>';" />
						</td>
					</tr>
				<?php
			}
		}
		else
		{
			?>
				<tr>
					<td colspan="10" align="center">-No Products have been configured-</td>
				</tr>
			<?php
		}
	?>
</table>

<?php
	if(isset($_REQUEST['action']) && ($_GET['action']=='create' || ($_GET['action']=='edit') && !isset($_POST['saveChanges'])))
	{
		//no default create new button, we will have a different "default" button of our own for this manage "action"
	}
	else
	{
		?>
			<input type="button" value="Create New" class="button-primary" 
				   onclick="window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php&action=create';" />
		<?php
	}
?>

<?php
	function edit_product()
	{
		global $wpdb;
		$id = wpr_sanitize($_GET['id']);
		
		//echo $id;
	
		if(isset($_POST['saveChanges']))
		{
			//the user is saving his changes
			$query = "SELECT * FROM ".$wpdb->prefix."EVI_PRODUCTS where id=$id";
			$result = $wpdb->get_results($query);
			$editedProduct = $result[0]->item_name;

			$name = wpr_sanitize($_POST['name']);
			$fid = wpr_sanitize($_POST['fid']);
			$aid = wpr_sanitize($_POST['aid']);

			$query = "UPDATE ".$wpdb->prefix."EVI_PRODUCTS SET fid=$fid, item_name='$name', aid=$aid WHERE id=$id";
			$result = $wpdb->query($query);

			?>
				<div id="message" class="updated">
					Changes for product '<?php echo($editedProduct); ?>' have been saved
				</div>
			<?php
			return;
		}
		$query = "select * from ".$wpdb->prefix."EVI_PRODUCTS where id=$id";
		$products = $wpdb->get_results($query);
		$product = $products[0];
	?>
		<div class="wrap">
			<h2>Edit Product</h2>
		</div>
		<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post">
			<table>
				<tr>
					<td>Product Name:</td>
					<td>
						<input type="text" name="name" value="<?php echo $product->item_name ?>" />
					</td>
				</tr>
				<tr>
					<td>Form/newsletter to let the customer to subscribe to when this product is sold:</td>
					<td>
						<select name="fid">
							<?php
								//form is optional
								echo '<option value=0';
								if ($product->fid == 0)
								{ 
									echo ' selected="selected"'; 
								} 
								echo '>None</option>';

								$forms = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_subscription_form");
								foreach ($forms as $form)
								{
									$newsletter = _wpr_newsletter_get($form->nid);

									?>
										<option value="<?php echo $form->id;?>"
											<?php
												if ($product->fid == $form->id)
												{
													echo ' selected="selected"';
												}
											?>
										>
											<?php echo $form->name.' | '.$newsletter->name ?>
										</option>
									<?php
								}
							?>
						</select>
					</td>
				</tr>
				<tr>
					<td>Autoresponder defining the email with digital product download link:</td>
					<td>
						<select name="aid">
							<?php
									$autoresponders = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_autoresponders");
									if (!count($autoresponders))
									{
										//no autoresponder defined
										echo '<option value=0 selected="selected" >No autoresponder available</option>';
									}
									else
									{
										//autoresponder is optional
										echo '<option value=0';
										if ($product->aid == 0)
										{ 
											echo ' selected="selected"'; 
										} 
										echo '>None</option>';

										foreach ($autoresponders as $autoresponder)
										{
											echo '<option value="'.$autoresponder->id.'"';
											if ($product->aid == $autoresponder->id)
											{ 
												echo ' selected="selected"';
											} 
											echo '>'.$autoresponder->name.'</option>';
										}
									}
								?>
						</select>
					</td>
				</tr>

				<tr>
					<td colspan="2">
						<input type="submit" name="saveChanges" value="Save" class="button-primary" />
						<input type="button" value="Cancel" onclick="window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php'" class="button" />
					</td>
				</tr>
			</table>
		</form>
	<?php
}

function delete_product()
{
	global $wpdb;
	$id = wpr_sanitize($_GET['id']);

	$query = "SELECT * FROM ".$wpdb->prefix."EVI_PRODUCTS where id=$id";
	$result = $wpdb->get_results($query);
	$deletedProduct = $result[0]->item_name;

	$query = "DELETE FROM ".$wpdb->prefix."EVI_PRODUCTS where id=$id";
	$wpdb->query($query);	
	?>
		<div id="message" class="updated">
			Product '<?php echo($deletedProduct); ?>' has been deleted
		</div>
	<?php
}

function create_product()
{
	global $wpdb;
	if (isset($_POST['name']))
	{
		//the user already entered the name of the product and so on in the form (see "else"), we will save the info into the db now
		$params = $_POST;
		$name = wpr_sanitize($_POST['name']);
		if ($name)
		{
			$fid = wpr_sanitize($_POST['fid']);
			$aid = wpr_sanitize($_POST['aid']);
			$query = "select * from ".$wpdb->prefix."EVI_PRODUCTS where item_name='$name'";
			$checkingRes = $wpdb->get_results($query);
			if (count($checkingRes))
			{
				?>
					<br/>
					<div style="color: red; font-weight: bold" align="center">					
						A product with the name '<?php echo($name); ?>' already exists. Please choose a different name.
					</div>
				<?php
				$_GET['action']='none';
				return;
			}
			else
			{
				$query = "INSERT INTO ".$wpdb->prefix."EVI_PRODUCTS (fid, item_name, aid) values ($fid,'$name', $aid)";
				$result = $wpdb->query($query);
				?>
					<script>window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php';</script>
				<?php
			}
		}
		else
		{
			?>
				<br/>
				<div style="color: red; font-weight: bold" align="center">
					Product Name is a required field
				</div>
				<br/>
				<a href="admin.php?page=enroll-via-ipn/EVI_products_setup.php">Back to product list.</a>
			<?php			
		}
	}
	else	//the user first needs to fill in a form with the product data
	{	
		?>
			<div class="wrap">
				<h2>Create Product</h2>
			</div>
			<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post">
				<table>
					<tr>
						<td>Product Name:</td>
						<td>
							<input type="text" name="name" value="" />
						</td>
					</tr>
					<tr>
						<td>Form/newsletter to let the customer to subscribe to when this product is sold:</td>
						<td>
							<select name="fid">
								<?php 
									//form is optional and defaults to none
									echo '<option value=0 selected="selected">None</option>';

									$forms = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_subscription_form");
									foreach ($forms as $form)
									{
										$newsletter = _wpr_newsletter_get($form->nid);

										?>
											<option value=<?php echo $form->id;?>>
												<?php echo $form->name.' | '.$newsletter->name ?>
											</option>
										<?php
									}
								?>
							</select>
						</td>
					</tr>
					<tr>
						<td>Autoresponder defining the email with digital product download link:</td>
						<td>
							<select name="aid">
								<?php
									$autoresponders = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."wpr_autoresponders");
									if (!count($autoresponders))
									{
										//no autoresponder defined
										echo '<option value=0 selected="selected" >No autoresponder available</option>';
									}
									else
									{
										//autoresponder is optional and defaults to none
										echo '<option value=0 selected="selected">None</option>';

										foreach ($autoresponders as $autoresponder)
										{
											echo '<option value="'.$autoresponder->id.'"';
											echo '>'.$autoresponder->name.'</option>';
										}
									}
								?>
							</select>
						</td>
					</tr>

					<tr>
						<td colspan="2">
							<input type="submit" value="Create" class="button-primary" />
							<input type="button" value="Cancel" onclick="window.location='admin.php?page=enroll-via-ipn/EVI_products_setup.php'" class="button" />
						</td>
					</tr>
				</table>
			</form>
		<?php
	}
}
?>